// 52cfc660-926a-4db5-8473-7d4ebade5784

function NeutrinoEffect(ctx) {

	var Db = this;

	var ne = function (Ld, Bd) {
		this.Ld = Ld;
		this.Bd = Bd;

		if (this.Bd.we.pe.length > 0) {
			this.we = this.Bd.we.pe[0];

			this.Lc = [ne.prototype.Ec,
				ne.prototype.Fc][this.we.xe];
		}
		else
			this.we = null;
	}

	ne.prototype = {
		Ec: function (fe, Ab, Xb) {
			var Gc = ctx.ib(Xb.Md);
			var Hc = Math.cos(Gc);
			var Ic = Math.sin(Gc);
			var ye = ctx.Ae(Xb.Nd[0]);
			var ze = ctx.Ae(Xb.Nd[1]);
			fe./**/transform(ye * Hc, ye * Ic, ze * -Ic, ze * Hc, Ab[0], Ab[1]);
		},

		Fc: function (fe, Ab, Xb) {
			var q = Xb.Mc;
			var z2 = 2.0 * q[2] * q[2];
			var xy = 2.0 * q[0] * q[1];
			var wz = 2.0 * q[3] * q[2];
			var ye = ctx.Ae(Xb.Nd[0]);
			var ze = ctx.Ae(Xb.Nd[1]);
			fe./**/transform(
				ye * (1.0 - 2.0 * q[1] * q[1] - z2),
				ye * (xy + wz),
				ze * (wz - xy),
				ze * (2.0 * q[0] * q[0] + z2 - 1.0),
				Ab[0], Ab[1]);
		},

		Pc: function (fe, Xb, ge) {
			Xb.vc(fe, -1, ge);

			if (this.we) {

				if (this.Be != null && !Xb.oc) {

					if (Xb.Od > 0.001) {
						var De = Math.floor(Xb.Qc % this.we.Rc);
						var Ee = Math.floor(Xb.Qc / this.we.Rc);

						var Ab = Xb.Ab.slice();
						var Nd = Xb.Nd.slice();
						if (!ge || ge./**/transform(Ab, Nd)) {

							var df = Math.abs(Nd[0]);
							var ef = Math.abs(Nd[1]);

							if (df > 0.001 && ef > 0.001) {						
								fe.save();
								this.Lc(fe, Ab, Xb);
								
								fe.translate(-df * Xb.Pd[0], -ef * (1 - Xb.Pd[1]));
								fe.globalAlpha = Xb.Od;

								if (Xb.gf[0] < 0.999 || Xb.gf[1] < 0.999 || Xb.gf[2] < 0.999) {

									var Ye = df < this.Tc ? df : this.Tc;
									var Ze = ef < this.Uc ? ef : this.Uc;

									ctx.af(Ye, Ze);

									ctx.bf.globalCompositeOperation = "copy";
									ctx.bf.drawImage(this.Be.image,
										this.Be.x + this.Tc * De, this.Be.y + this.Uc * Ee,
										this.Tc, this.Uc,
										0, 0, Ye, Ze);

									ctx.bf.globalCompositeOperation = "multiply";
									ctx.bf.fillStyle = ctx.ff(Xb.gf);
									ctx.bf.fillRect(0, 0, Ye, Ze);

									ctx.bf.globalCompositeOperation = "destination-atop";
									ctx.bf.drawImage(this.Be.image,
										this.Be.x + this.Tc * De, this.Be.y + this.Uc * Ee,
										this.Tc, this.Uc,
										0, 0, Ye, Ze);

									fe.drawImage(ctx.cf, 0, 0, Ye, Ze, 0, 0, df, ef);
								}
								else {
									fe.drawImage(this.Be.image,
										this.Be.x + this.Tc * De, this.Be.y + this.Uc * Ee,
										this.Tc, this.Uc, 0, 0, df, ef);
								}

								fe.restore();
							}
						}
					}
				}
			}

			Xb.vc(fe, 1, ge);
		},

		Hd: function (fe, ge) {
			fe.save();

			if (this.we) {
				fe.globalCompositeOperation = this.Ld.materials[this.Ld./**/model.renderStyles[this.we.renderStyleIndex].materialIndex];
				this.Be = this.Ld.textureDescs[this.Ld./**/model.renderStyles[this.we.renderStyleIndex].textureIndices[0]];
			}
			else {
				this.Be = null;
			}

			if (this.Be) {
				this.Tc = this.Be.width / this.we.Rc;
				this.Uc = this.Be.height / this.we.Sc;
			}

			function kd(a, b) {
				if (a.Ab[2] < b.Ab[2])
					return 1;
				if (a.Ab[2] > b.Ab[2])
					return -1;
				return 0;
			}

			switch (this.Bd.Vc) {
				case 0:
					for (var Wb = 0; Wb < this.Bd.tc.length; ++Wb) {
						this.Pc(fe, this.Bd.tc[Wb], ge);
					}
					break;
				case 1:
					for (var Wb = this.Bd.tc.length; Wb-- > 0;) {
						this.Pc(fe, this.Bd.tc[Wb], ge);
					}
					break;
				case 2:
					this.Bd.tc.sort(kd);

					for (var Wb = 0; Wb < this.Bd.tc.length; ++Wb) {
						this.Pc(fe, this.Bd.tc[Wb], ge);
					}
					break;
			}

			fe.restore();
		}
	}

	var oe = function (Ld, Bd) {

		this.Ld = Ld;
		this.Bd = Bd;

		if (this.Bd.we.pe.length > 0)
			this.we = this.Bd.we.pe[0];
		else
			this.we = null;

		this.vertex = [
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] },
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] },
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] },
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] }];
	}

	oe.prototype = {
		qe: function (Xb, se, re, te, renderBuffer) {
			Xb.Ce(-1, se, re, te, renderBuffer);

			if (this.we) {

				if (!Xb.oc) {

					var v0 = this.vertex[0];
					var v1 = this.vertex[1];
					var v2 = this.vertex[2];
					var v3 = this.vertex[3];

					var Fe = [], Ge = [];

					if (this.we.xe == 0) {
						var a = ctx.ib(Xb.Md);
						var s = Math.sin(a);
						var c = Math.cos(a);

						Fe[0] = se[0] * c + re[0] * s;
						Fe[1] = se[1] * c + re[1] * s;
						Fe[2] = se[2] * c + re[2] * s;

						Ge[0] = -se[0] * s + re[0] * c;
						Ge[1] = -se[1] * s + re[1] * c;
						Ge[2] = -se[2] * s + re[2] * c;
					}
					else {
						var q = Xb.Mc;
						var z2 = 2.0 * q[2] * q[2];
						var xy = 2.0 * q[0] * q[1];
						var wz = 2.0 * q[3] * q[2];

						Fe[0] = 1.0 - 2.0 * q[1] * q[1] - z2;
						Fe[1] = xy + wz;
						Fe[2] = 2.0 * q[0] * q[2] - 2.0 * q[3] * q[1];

						Ge[0] = xy - wz;
						Ge[1] = 1.0 - 2.0 * q[0] * q[0] - z2;
						Ge[2] = 2.0 * q[1] * q[2] + 2.0 * q[3] * q[0];
					}

					var He = [], Ie = [], Je = [], Ke = [];
					ctx.u(He, Fe, -Xb.Nd[0] * Xb.Pd[0]);
					ctx.u(Ie, Fe, Xb.Nd[0] * (1.0 - Xb.Pd[0]));
					ctx.u(Je, Ge, -Xb.Nd[1] * Xb.Pd[1]);
					ctx.u(Ke, Ge, Xb.Nd[1] * (1.0 - Xb.Pd[1]));

					ctx.c(v0./**/position, He, Je);
					ctx.c(v0./**/position, v0./**/position, Xb.Ab);
					ctx.c(v1./**/position, He, Ke);
					ctx.c(v1./**/position, v1./**/position, Xb.Ab);
					ctx.c(v2./**/position, Ie, Ke);
					ctx.c(v2./**/position, v2./**/position, Xb.Ab);
					ctx.c(v3./**/position, Ie, Je);
					ctx.c(v3./**/position, v3./**/position, Xb.Ab);

					{
						var rgb = ctx.v(Xb.gf, 255);
						v0./**/color = v1./**/color = v2./**/color = v3./**/color = [rgb[0], rgb[1], rgb[2], Xb.Od * 255];
					}

					{
						var De = Math.floor(Xb.Qc % this.we.Rc);
						var Ee = Math.floor(Xb.Qc / this.we.Rc);

						var Pe, Qe, Re, Se;

						var We = this.Ld.texturesRemap[this.Ld./**/model.renderStyles[this.we.renderStyleIndex].textureIndices[0]];
						if (We) {
							var Ue = We.width / this.we.Rc;
							var Ve = We.height / this.we.Sc;

							var Pe = We.x + De * Ue;
							var Qe = Pe + Ue;
							var Re = (We.y + We.height - Ee * Ve);
							var Se = Re - Ve;
						} else {
							var Ue = 1.0 / this.we.Rc;
							var Ve = 1.0 / this.we.Sc;

							var Pe = De * Ue;
							var Qe = Pe + Ue;
							var Re = (1.0 - Ee * Ve);
							var Se = Re - Ve;
						}

						v0./**/texCoords[0] = [Pe, Se];
						v1./**/texCoords[0] = [Pe, Re];
						v2./**/texCoords[0] = [Qe, Re];
						v3./**/texCoords[0] = [Qe, Se];
					}

					renderBuffer.pushVertex(v0);
					renderBuffer.pushVertex(v1);
					renderBuffer.pushVertex(v2);
					renderBuffer.pushVertex(v3);

					if (!renderBuffer.__lastRenderCall) {
						renderBuffer.__lastRenderCall = new ctx.RenderCall(0, 6, this.we.renderStyleIndex);
					} else {
						var lastRenderCall = renderBuffer.__lastRenderCall;

						if (lastRenderCall.renderStyleIndex == this.we.renderStyleIndex) {
							lastRenderCall.numIndices += 6;
						} else {
							renderBuffer.pushRenderCall(lastRenderCall);
							renderBuffer.__lastRenderCall = new ctx.RenderCall(
								lastRenderCall.startIndex + lastRenderCall.numIndices,
								6, this.we.renderStyleIndex);
						}
					}
				}
			}

			Xb.Ce(1, se, re, te, renderBuffer);
		},

		ue: function (se, re, te, renderBuffer) {
			switch (this.Bd.Vc) {
				case 0:
					for (var Wb = 0; Wb < this.Bd.tc.length; ++Wb) {
						this.qe(this.Bd.tc[Wb], se, re, te, renderBuffer);
					}
					break;

				case 1:
					for (var Wb = this.Bd.tc.length; Wb-- > 0;) {
						this.qe(this.Bd.tc[Wb], se, re, te, renderBuffer);
					}
					break;

				case 2:
					this.Bd.tc.forEach(function (Xb) {
						Xb.depth = ctx.H(te, Xb.Ab);
					});

					this.Bd.tc.sort(function (a, b) {
						if (a.depth < b.depth)
							return 1;
						if (a.depth > b.depth)
							return -1;
						return 0;
					});

					this.Bd.tc.forEach(function (Xb) {
						this.qe(Xb, se, re, te, renderBuffer);
					}, this);
					break;
			}
		}
	}

	var ld = function (Ld, we, ve) {
		var Vb = this;
		this.Ld = Ld;
		this.we = we;

		// Eb

		function Eb() {
			this.Fb = 0;
			this.Gb = 1;
			this.Hb = null;
			this.Ib = null;
			this.Kb = 0;
			this.Lb = 1;

			Vb.we.Mb(this); // IMPL

			this.Nb = function () {
				this.Ob = this.Gb;
				this.Fb = 0;
			}

			this.Nb();
		}

		Eb.prototype = {
			Jd: function () {
				this.Nb();
			},

			Id: function (Qb, Ab, Mc) {
				Vb.we.Pb(Qb, Vb, this); // IMPL

				var Rb = Vb.Rb;
				var systemTime = Ld.Rb;
				var Sb = Qb;
				var ic = 0;

				if (this.zb > 0.000001) {

					var Tb = this.Ob + Qb * this.zb;

					while (Tb >= 1.0) {
						var Ub = this.zb < 0.001 ? 0.0 : (1.0 - this.Ob) / this.zb;
						Sb -= Ub;
						Rb += Ub;
						systemTime += Ub;

						if (this.Hb != null && Rb > this.Hb) {
							Vb.disactivate();
							break;
						}

						Vb.Rb = Rb;
						Ld.Rb = systemTime;

						if (Ab && Qb > 0)
							ctx.ab(Vb.Ab, Ab, Vb.Bb, Sb / Qb);

						if (Mc && Qb > 0)
							ctx.slerpq(Vb.Mc, Mc, Vb.prevRotation, Sb / Qb);

						// for the future when Jb would be external
						this.Lb = this.Jb;

						for (var Wb = 0; Wb < this.Jb; ++Wb) {
							if (Vb.sc.length == 0)
								break;

							if (this.Jb == 1)
								this.Kb = 0;
							else
								this.Kb = Wb / (this.Jb - 1);

							var Xb = Vb.sc.pop();
							Vb.tc.unshift(Xb);

							if (Wb == 0)
								Xb.Yb();
							else
								Xb.Zb();

							Xb.Id(Sb);
							++ic;
						}

						this.Ob = 0.0;
						Tb -= 1.0;

						if (this.Ib != null && ++this.Fb >= this.Ib) {
							Vb.disactivate();
							break;
						}
					}

					this.Ob = Tb;
				}
				Rb += Sb;
				Vb.Rb = Rb;

				if (Ab)
					ctx.T(Vb.Ab, Ab);

				if (Mc)
					ctx.T(Vb.Mc, Mc);

				return ic;
			}
		}

		// ac

		function ac() {
			this.Gb = 1;
			this.Kb = 0;
			this.Lb = 1;

			Vb.we.Mb(this); // IMPL

			this.Nb = function () {
				this.bc = this.Gb;
			}

			this.Nb();
		}

		ac.prototype = {
			Jd: function () {
				this.Nb();
			},

			Id: function (Qb, Ab, Mc) {
				Vb.we.Pb(Qb, Vb, this); // IMPL

				var cc = Vb.Rb;
				var dc = cc + Qb;
				var systemTimeBeforeFrame = Ld.Rb;
				var systemTimeAfterFrame = systemTimeBeforeFrame + Qb;
				var ec = Ab ? ctx.O(ctx.h(Ab, Vb.Bb)) : 0;
				var ic = 0;

				if (ec > 0.000001) {
					var fc = ec / this.rd;
					var Tb = this.bc + fc;

					var hc = fc < 0.001 ?
						1.0 - this.bc : (1.0 - this.bc) / fc;

					var jc = [];

					while (Tb > 1.0) {
						var kc = cc + hc * Qb;

						if (Ab)
							ctx.ab(jc, Vb.Bb, Ab, hc);

						if (Mc)
							ctx.slerpq(currentEmitterRot, Vb.prevRotation, Mc, hc);

						Vb.Rb = kc;
						ctx.T(Vb.Ab, jc);
						Ld.Rb = ctx.X(systemTimeBeforeFrame, systemTimeAfterFrame, hc);

						// for the future when Jb would be external
						this.Lb = this.Jb;

						for (var Wb = 0; Wb < this.Jb; ++Wb) {
							if (Vb.sc.length == 0)
								break;

							if (this.Jb == 1)
								this.Kb = 0;
							else
								this.Kb = Wb / (this.Jb - 1);

							var Xb = Vb.sc.pop();
							Vb.tc.unshift(Xb);

							if (Wb == 0)
								Xb.Yb();
							else
								Xb.Zb();

							Xb.Id(Qb * (1.0 - hc));
							++ic;
						}

						hc += 1.0 / fc;
						Tb -= 1.0;
					}

					this.bc = Tb;
				}

				Vb.Rb = dc;

				if (Ab)
					ctx.T(Vb.Ab, Ab);

				if (Mc)
					ctx.U(Vb.Mc, Mc);

				return ic;
			}
		}

		// mc

		function mc() {
			this.Ab = [];
			this.Pd = [];
			this.Nd = [];
			this.gf = [];
			this.Kc = [];
		}

		mc.prototype = {
			nc: function () {
				this.oc = false;

				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];
					pc.Bd.Jd(this.Ab, null);

					if (pc.Ad.sd)
						pc.Bd.disactivate();
				}
			},

			Yb: function () {
				Vb.we.fd(Vb, this); // IMPL
				this.nc();
			},

			Zb: function () {
				Vb.we.gd(Vb, this); // IMPL
				this.nc();
			},

			Id: function (Qb) {
				Vb.we.qc(Qb, Vb, this); // IMPL

				this.rc(Qb);
			},

			pc: function (je) {
				return this.Kc[je].Bd;
			},

			rc: function (Qb) {
				for (var i = 0; i < this.Kc.length; i++) {
					this.Kc[i].Bd.Id(Qb, this.Ab, null);
				}
			},

			uc: function (md, nd) {
				this.Kc.push({
					Bd: new ld(Ld, md, ve),
					Ad: nd
				});
			},

			vc: function (fe, xc, ge) {
				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];

					if (xc == pc.Ad.xc)
						pc.Bd.Hd(fe, ge);
				}
			},

			Ce: function (xc, se, re, te, renderBuffer) {
				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];

					if (xc == pc.Ad.xc)
						pc.Bd.ue(se, re, te, renderBuffer);
				}
			},

			wc: function (fe) {
				this.oc = true;
				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];

					if (pc.Ad.sd)
						pc.Bd.activate();
					else
						pc.Bd.disactivate();
				}
			},

			yc: function (Gd) {
				for (var i = 0; i < this.Kc.length; ++i) {
					this.Kc[i].Bd.Ed(Gd);
				}
			}
		}

		// zc

		function zc() {
		}

		zc.prototype.Ac = function (Xb) {
			return Vb.we.Cc(Vb, Xb, this); // IMPL
		}

		// ld Ad

		this.Ab = [];
		this.Bb = [];
		this.Mc = [];
		this.prevRotation = [];
		this.tc = [];
		this.sc = [];
		this.Wc = new zc();
		this.construct = new ve(this.Ld, this);
		this.Yc = [];
		this.ad = [];

		this.dd = function () {
			this.vd = new Eb();
		}

		this.ed = function () {
			this.vd = new ac();
		}

		this.we.ud(this); // IMPL

		for (var Wb = 0; Wb < this.jd; ++Wb) {
			var Xb = new mc();

			for (var id = 0; id < this.Yc.length; ++id) {
				var hd = this.Yc[id];
				Xb.uc(hd.Db, hd.Ad);
			}

			this.sc.push(Xb);
		}

		this.Nb = function (Ab, Mc) {

			ctx.T(this.Ab, Ab ? Ab : [0, 0, 0]);
			ctx.T(this.Bb, this.Ab);
			ctx.U(this.Mc, Mc ? Mc : [0, 0, 0, 1]);
			ctx.U(this.prevRotation, this.Mc);

			this.Rb = 0.0;
			this.wd = 0.0;
			this.Zc = true;
			this.paused_ = false;
			this.generatorsPaused_ = false;
			ctx.W(this.ad, 0, 0, 0);
		}
	}

	ld.prototype.Jd = function (Ab, Mc) {
		this.Nb(Ab, Mc);

		this.sc.push.apply(this.sc, this.tc);
		this.tc.length = 0;

		this.vd.Jd();
	}

	ld.prototype.Id = function (Qb, Ab, Mc) {

		if (this.paused_)
		{
			this.Td(Ab, Mc);
			return;
		}

		this.wd = this.Rb;

		if (Ab) {
			ctx.T(this.Bb, this.Ab);
			if (Qb > 0.0001) {
				var shift = [];
				ctx.g(shift, Ab, this.Bb);
				ctx.T(this.ad, shift);
				ctx.w(this.ad, this.ad, Qb);
			}
			else {
				ctx.W(this.ad, 0, 0, 0);
			}
		}
		else {
			ctx.W(this.ad, 0, 0, 0);
		}

		if (Mc)
		{
			ctx.U(this.prevRotation, this.Mc);
		}

		var ic;

		if (this.Zc && !this.generatorsPaused_) {
			ic = this.vd.Id(Qb, Ab, Mc);
		}
		else {
			if (Ab)
				ctx.T(this.Ab, Ab);

			if (Mc)
				ctx.U(this.Mc, Mc);

			ic = 0;
			this.Rb += Qb;
		}

		for (var Wb = ic; Wb < this.tc.length;) {
			var Xb = this.tc[Wb];

			if (!Xb.oc) {
				Xb.Id(Qb);

				if (this.Wc.Ac(this.tc[Wb])) {
					Xb.wc();

					if (this.xd(Wb))
						continue;
				}
			}
			else {
				Xb.rc(Qb);

				if (this.xd(Wb))
					continue;
			}

			++Wb;
		}
	};

	ld.prototype.xd = function (je) {
		var Xb = this.tc[je];

		var ready = true;

		for (var id = 0; id < Xb.Kc.length; ++id) {
			var Bd = Xb.Kc[id].Bd;

			if (Bd.activated() || Bd.tc.length > 0) {
				ready = false;
				break;
			}
		}

		if (ready) {
			this.sc.push(this.tc[je]);
			this.tc.splice(je, 1);
			return true;
		}

		return false;
	}

	ld.prototype.Hd = function (fe, ge) {
		this.construct.Hd(fe, ge);
	}

	ld.prototype.ue = function (se, re, te, renderBuffer) {
		this.construct.ue(se, re, te, renderBuffer);
	}

	ld.prototype.Td = function (Ab, Mc) {
		this.wd = this.Rb;

		if (Ab) {
			ctx.T(this.Bb, this.Ab);
			ctx.T(this.Ab, Ab);
		}

		if (Mc) {
			ctx.U(this.prevRotation, this.Mc);
			ctx.U(this.Mc, Mc);
		}
	}

	ld.prototype.uc = function (md, nd) {
		this.Yc.push({ Db: md, Ad: nd });
	}

	ld.prototype./**/pause = function () {
		this.paused_ = true;
	}

	ld.prototype./**/unpause = function () {
		this.paused_ = false;
	}

	ld.prototype./**/paused = function () {
		return this.paused_;
	}

	ld.prototype./**/pauseGenerators = function () {
		this.generatorsPaused_ = true;
	}

	ld.prototype./**/unpauseGenerators = function () {
		this.generatorsPaused_ = false;
	}

	ld.prototype./**/generatorsPaused = function () {
		return this.generatorsPaused_;
	}

	ld.prototype.activate = function () {
		this.Zc = true;
	}

	ld.prototype.disactivate = function () {
		this.Zc = false;
	}

	ld.prototype.activated = function () {
		return this.Zc;
	}
	
	ld.prototype./**/getNumParticles = function () {
		return this.tc.length;
	}

	var ke = function () {
		var Cb = this;

		this._init = function (we, Ab, Mc, ve) {
			this./**/model = we;

			this.Ab = [];
			this.Mc = [];

			// ke Ad

			this.od = [];

			this.pd = function (md) {
				var Bd = new ld(this, md, ve);
				Bd.Nb(this.Ab, this.Mc);
				this["_".concat(md.name)] = Bd;
				this.od.push(Bd);
			}

			this.Nb = function (Ab, Mc) {
				this.Cd = 0.0;
				this.Rb = 0.0;
				ctx.T(this.Ab, Ab ? Ab : [0, 0, 0]);
				ctx.U(this.Mc, Mc ? Mc : [0, 0, 0, 1]);
			}

			this.Nb(Ab, Mc);
			this./**/model.qd(this); // IMPL
			this.zeroUpdate();
			this./**/update(this.Ud, Ab, Mc);
		}
	}

	ke.prototype./**/restart = function (/**/position, /**/rotation) {

		this.Nb(/**/position ? /**/position : this.Ab, /**/rotation ? /**/rotation : this.Mc);

		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Jd(this.Ab, this.Mc);
		}

		this.zeroUpdate();

		this./**/update(this.Ud, this.Ab, this.Mc);
	}

	ke.prototype.zeroUpdate = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Id(0, this.Ab, this.Mc);
		}
	}

	ke.prototype./**/update = function (/**/dt, /**/position, /**/rotation) {
		var updatedTime = 0.0;
		var hc = [];
		ctx.T(hc, this.Ab);
		var frameRotation = [];
		ctx.U(frameRotation, this.Mc);

		if (/**/position && ctx.equalv3_(/**/position, this.Ab))
			/**/position = null;

		if (/**/rotation && ctx.equalq_(/**/rotation, this.Mc))
			/**/rotation = null;

		while ((/**/dt - updatedTime) + this.Cd >= this.Dd) {
			var cc = this.Rb;

			if (/**/position)
				ctx.ab(hc, this.Ab, /**/position, updatedTime / /**/dt);

			if (/**/rotation)
				ctx.slerpq(frameRotation, this.Mc, /**/rotation, updatedTime / /**/dt);

			for (var i = 0; i < this.od.length; ++i) {
				this.od[i].Id(this.Dd, hc, frameRotation);

				this.Rb = cc;
			}

			updatedTime += this.Dd - this.Cd;
			this.Cd = 0.0;
			this.Rb = cc + this.Dd;
		}

		if (/**/position)
			ctx.T(this.Ab, /**/position);

		if (/**/rotation)
			ctx.U(this.Mc, /**/rotation);

		this.Cd += /**/dt - updatedTime;
	}

	ke.prototype./**/resetPosition = function (/**/position, /**/rotation) {

		if (/**/position)
			ctx.T(this.Ab, /**/position);

		if (/**/rotation)
			ctx.U(this.Mc, /**/rotation);

		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Td(this.Ab, this.Mc);
		}
	}

	ke.prototype./**/setPropertyInAllEmitters = function (/**/name, /**/value) {
		var propName = "_".concat(/**/name);

		if (/**/value instanceof Array) {
			if (/**/value.length == 2) {
				for (var i = 0; i < this.od.length; ++i) {
					ctx.S(this.od[i][propName], /**/value);
				}
			}
			else {
				for (var i = 0; i < this.od.length; ++i) {
					ctx.T(this.od[i][propName], /**/value);
				}
			}
		}
		else {
			for (var i = 0; i < this.od.length; ++i) {
				this.od[i][propName] = /**/value;
			}
		}
	}

	ke.prototype./**/pauseAllEmitters = function() {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/pause();
		}
	}

	ke.prototype./**/unpauseAllEmitters = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/unpause();
		}
	}

	ke.prototype./**/areAllEmittersPaused = function () {
		for (var i = 0; i < this.od.length; ++i) {
			if (!this.od[i].paused())
				return false;
		}
		return true;
	}

	ke.prototype./**/pauseGeneratorsInAllEmitters = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/pauseGenerators();
		}
	}

	ke.prototype./**/unpauseGeneratorsInAllEmitters = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/unpauseGenerators();
		}
	}

	ke.prototype./**/areGeneratorsInAllEmittersPaused = function () {
		for (var i = 0; i < this.od.length; ++i) {
			if (!this.od[i].generatorsPaused())
				return false;
		}
		return true;
	}

	ke.prototype./**/getNumParticles = function() {
		var numParticles = 0;
		
		for (var i = 0; i < this.od.length; ++i) {
			numParticles += this.od[i].getNumParticles();
		}
		
		return numParticles;
	}
	

	var le = function () {
		this._init = function (we, Ab, Mc, renderBuffer) {
			le.prototype._init.call(this, we, Ab, Mc, oe);

			this.texturesRemap = [];

			var indices = [];

			{
				var verDisp;
				for (var Wb = 0; Wb < this./**/model.Xe; ++Wb) {
					verDisp = Wb * 4;
					indices.push(verDisp + 0, verDisp + 3, verDisp + 1, verDisp + 1, verDisp + 3, verDisp + 2);
				}
			}

			this.renderBuffer = renderBuffer;
			this.renderBuffer.initialize(this./**/model.Xe * 4, [2], indices, this./**/model.Xe);
			this.renderBuffer.__numIndices = 0;
		}
	}

	le.prototype = new ke();

	le.prototype./**/fillGeometryBuffers = function (/**/cameraRight, /**/cameraUp, /**/cameraDir) {
		this.renderBuffer.cleanup();
		this.renderBuffer.__lastRenderCall = null;

		this.od.forEach(function (Bd) {
			Bd.ue(/**/cameraRight, /**/cameraUp, /**/cameraDir, this.renderBuffer);
		}, this);

		if (this.renderBuffer.__lastRenderCall)
			this.renderBuffer.pushRenderCall(this.renderBuffer.__lastRenderCall);
	}

	var me = function () {
		this._init = function (we, Ab, Mc) {
			me.prototype._init.call(this, we, Ab, Mc, ne);

			this.materials = [];
			this./**/model.materials.forEach(function (value) {
				this.materials.push(['source-over', 'lighter', 'multiply'][value]);
			}, this);

			this./**/textureDescs = [];
		}
	}

	me.prototype = new ke();

	me.prototype./**/draw = function (/**/context, /**/camera) {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Hd(/**/context, /**/camera);
		}
	}

	this.createWGLInstance = function (/**/position, /**/rotation, /**/renderBuffer) {
		var Ld = new le();
		Ld._init(this, /**/position, /**/rotation, /**/renderBuffer);
		return Ld;
	}

	this.createCanvas2DInstance = function (/**/position, /**/rotation) {
		var Ld = new me();
		Ld._init(this, /**/position, /**/rotation);
		return Ld;
	}
	this.textures = ['smoke_particles_n2.png','smoke_particles2_2.png','sphere.png'];
	this.materials = [1,0];
	this.renderStyles = [{materialIndex:0,textureIndices:[0]},{materialIndex:0,textureIndices:[1]},{materialIndex:1,textureIndices:[2]}];
	this.Xe = 300;

	function Emitter_DefaultEmitter() {

		var _5s = [[9.85185, 9.25], [19.7037, 9.25], [29.5556, 18.5], [39.4074, 18.5], [9.85185, 18.5], [19.7037, 18.5]], _, _4, _5Srch, _5 = [], _6 = [], _8, _9 = [], _9i, _9s = [], _10 = [], _12, _14, _15, _17, _19, _21, _22, _23=[], _23a=[], _23i=[], _24=[], _24fs=[], _24vs=[], _24rw=[], _24rwn=[], _24rwl, _24v=[], _24p=[], _24dtl, _24dtp, _24df, _24fsd=[], _25, _26, _27, _27i0, _27s0 = [], _28, _29, _29i0, _29s0 = [], _30;
		this.pe = [{xe:0,Rc:10,Sc:6,renderStyleIndex:0}];
		this.name = "DefaultEmitter";

		this.ud = function(Bd) {
			Bd.dd();
			Bd._9 = [
				[[-127.903,-88.9612],[-126.664,-93.1259],[-125.239,-97.231],[-123.617,-101.262],[-121.786,-105.202],[-119.734,-109.032],[-117.454,-112.731],[-114.939,-116.273],[-112.186,-119.634],[-109.197,-122.788],[-105.981,-125.708],[-102.549,-128.373],[-98.9206,-130.762],[-95.117,-132.861],[-91.163,-134.661],[-87.0846,-136.158],[-87.0846,-136.158]]
			];
			Bd._27 = [
				[
					[0.6,0.650561,0.695834,0.736149,0.771888,0.803485,0.831409,0.856157,0.878243,0.898187,0.916501,0.933681,0.950198,0.966494,0.982973,1,1]
				]
			];
			Bd._29 = [
				[
					[0,0.0291447,0.0697997,0.122364,0.18694,0.263151,0.349906,0.445151,0.545668,0.647062,0.744058,0.831122,0.903259,0.956697,0.989199,1,1],
					[1,1,1],
					[1,0.999016,0.995779,0.989793,0.980449,0.966991,0.948465,0.923645,0.89092,0.848121,0.792224,0.718828,0.621157,0.487892,0.297632,0,0]
				]
			];
			Bd.jd = 100;
			Bd.Vc = 0;
		}

		this.Mb = function(vd) {
			vd.zb = 30;
			vd.Gb = 1;
			vd.Jb = 1;
		}

		this.Pb = function(Qb, Bd, vd) {
			vd.zb = 30;
		}

		this.fd = function(Bd, Xb) {
			_ = 1.2 + Bd.Ld.rand() * (2 - 1.2);
			Xb._1 = _;
			Xb._2 = 0.0;
			Xb._3 = 0;
			_4 = 0 + Bd.Ld.rand() * (1 - 0);
			_5Srch = this._5f(_4 * 61506);
			ctx.yb(_5, 361 + (_5Srch[0] % 54) * 9.85185, 551 + Math.floor(_5Srch[0] / 54) * 9.25, _5s[_5Srch[1]], Bd.Ld.rand);
			ctx.W(_6, _5[0], _5[1], 0);
			Xb._7 = [];
			ctx.T(Xb._7, _6);
			_8 = 0 + Bd.Ld.rand() * (1 - 0);
			_9i = Db.kb(_8);
			ctx.V(_9s,0,(_9i-0)*15);
			Db.lb(_9, Bd._9[_9s[0]], _9s[1]);
			ctx.W(_10, _9[0], _9[1], 0);
			Xb._11 = [];
			ctx.T(Xb._11, _10);
			_12 = 0.1 + Bd.Ld.rand() * (0.25 - 0.1);
			Xb._13 = _12;
			_14 = 0.6 + Bd.Ld.rand() * (1 - 0.6);
			_15 = (_14 * 220);
			Xb._16 = _15;
			_17 = 0 + Bd.Ld.rand() * (360 - 0);
			Xb._18 = _17;
			_19 = -40 + Bd.Ld.rand() * (30 - -40);
			Xb._20 = _19;
			ctx.T(Xb.Ab, Xb._7);
		}

		this.gd = function(Bd, Xb) {
			_ = 1.2 + Bd.Ld.rand() * (2 - 1.2);
			Xb._1 = _;
			Xb._2 = 0.0;
			Xb._3 = 0;
			_4 = 0 + Bd.Ld.rand() * (1 - 0);
			_5Srch = this._5f(_4 * 61506);
			ctx.yb(_5, 361 + (_5Srch[0] % 54) * 9.85185, 551 + Math.floor(_5Srch[0] / 54) * 9.25, _5s[_5Srch[1]], Bd.Ld.rand);
			ctx.W(_6, _5[0], _5[1], 0);
			Xb._7 = [];
			ctx.T(Xb._7, _6);
			_8 = 0 + Bd.Ld.rand() * (1 - 0);
			_9i = Db.kb(_8);
			ctx.V(_9s,0,(_9i-0)*15);
			Db.lb(_9, Bd._9[_9s[0]], _9s[1]);
			ctx.W(_10, _9[0], _9[1], 0);
			Xb._11 = [];
			ctx.T(Xb._11, _10);
			_12 = 0.1 + Bd.Ld.rand() * (0.25 - 0.1);
			Xb._13 = _12;
			_14 = 0.6 + Bd.Ld.rand() * (1 - 0.6);
			_15 = (_14 * 220);
			Xb._16 = _15;
			_17 = 0 + Bd.Ld.rand() * (360 - 0);
			Xb._18 = _17;
			_19 = -40 + Bd.Ld.rand() * (30 - -40);
			Xb._20 = _19;
			ctx.T(Xb.Ab, Xb._7);
		}

		this.qc = function(Qb, Bd, Xb) {
			Xb._2 += Qb;
			_21 = Xb._3 + Qb * 30;
			Xb._3 = _21;
			_22 = ctx.d(Xb._7, ctx.v([-100, 50, 20], Bd.Rb));
			ctx.u(_23a, [0,0,0], Bd.Ld.Rb);
			ctx.c(_23a, _23a, _22);
			ctx.u(_23i, _23a, 1.0 / 1000); 
			ctx.xb(_23, _23i);
			ctx.k(_23, _23, [-0.00664063,-0.00546875,0]);
			ctx.c(_23, _23, [0.7,0.6,0]);
			ctx.u(_23, _23, 200);
			ctx.T(_24fs, _23);
			ctx.T(_24vs, [0,0,0]);
			_24dtl = Qb;
			ctx.T(_24v, Xb._11);
			ctx.T(_24p, Xb._7);
			while (_24dtl > 0.0001) {
				_24dtp = _24dtl;
				ctx.T(_24fsd, _24fs);
				ctx.g(_24rw, _24vs, _24v);
				_24rwl = ctx.P(_24rw);
				if (_24rwl > 0.0001) {
					_24rwl = Math.sqrt(_24rwl);
					ctx.w(_24rwn, _24rw, _24rwl);
					_24df = 0.01 * 1 * _24rwl;
					if (_24df * _24dtp > 0.2) 
						_24dtp = 0.2 / _24df;
					ctx.c(_24fsd, _24fsd, ctx.v(_24rwn, _24rwl * _24df));
				}
				ctx.c(_24v, _24v, ctx.v(_24fsd, _24dtp));
				ctx.c(_24p, _24p, ctx.v(_24v, _24dtp));
				_24dtl -= _24dtp;
			}
			ctx.T(Xb._7, _24p);
			ctx.T(Xb._11, _24v);
			_25 = Xb._18 + Qb * Xb._20;
			Xb._18 = _25;
			ctx.T(Xb.Ab, Xb._7);
			_26 = (Xb._2 / Xb._1);
			_27i0=(_26<0?0:(_26>1?1:_26));
			ctx.V(_27s0,0,(_27i0-0)*15);
			_27 = Db.nb(Bd._27[0][_27s0[0]],_27s0[1]);
			_28 = (Xb._16 * _27);
			_29i0=(_26<0?0:(_26>1?1:_26));
			_29i0<0.4?_29i0<0.348326?ctx.V(_29s0,0,(_29i0-0)*43.0631):ctx.V(_29s0,1,(_29i0-0.348326)*19.3522):ctx.V(_29s0,2,(_29i0-0.4)*25);
			_29 = Db.nb(Bd._29[0][_29s0[0]],_29s0[1]);
			_30 = (Xb._13 * _29);
			ctx.S(Xb.Pd,[0.5,0.5]);
			Xb.Md = Xb._18;
			ctx.V(Xb.Nd,_28,_28);
			ctx.T(Xb.gf,[1,1,1]);
			Xb.Od = _30;
			Xb.Qc = Xb._3;
		}

		this.Cc = function(Bd, Xb, Wc) {
			return Xb._2 > Xb._1;
		}

			this._5f = function(i) {
				return i<28238?i<12585?i<4936?i<72?i<16?[167,0]:[168,0]:i<2251?i<1147?i<338?i<89?[217,0]:i<115?[270,0]:[271,0]:i<637?i<453?[218,0]:[219,0]:[272,1]:i<1602?i<1531?i<1276?[324,0]:[325,0]:i<1552?[378,0]:[379,0]:i<2111?i<1856?[326,0]:[327,0]:i<2149?[380,0]:[381,0]:i<3744?i<3234?i<2724?i<2472?[220,0]:[221,0]:[274,1]:[222,4]:i<4544?i<4254?[328,1]:i<4387?[382,0]:[383,0]:i<4799?[330,0]:[384,0]:i<5863?i<5324?i<5097?i<5006?[169,0]:[170,0]:i<5202?[171,0]:[172,0]:i<5665?i<5485?[173,0]:[174,0]:[175,0]:i<9644?i<7903?[223,3]:i<8712?i<8413?[331,1]:i<8550?[385,0]:[386,0]:i<9222?[333,1]:i<9420?[387,0]:[388,0]:i<11174?[227,2]:i<12124?i<11684?[335,1]:i<11910?[389,0]:[390,0]:i<12379?[337,0]:[391,0]:i<20876?i<14468?i<13576?i<13057?i<12590?[123,0]:i<12813?[176,0]:[177,0]:i<13075?i<13064?[124,0]:[125,0]:i<13325?[178,0]:[179,0]:i<14155?i<13646?i<13605?[126,0]:[127,0]:i<13900?[180,0]:[181,0]:i<14213?[128,0]:[182,0]:i<18219?i<16506?i<15488?[230,5]:i<15997?i<15742?[232,0]:[233,0]:i<16251?[286,0]:[287,0]:i<17389?i<17016?[338,1]:i<17208?[392,0]:[393,0]:i<17899?[340,1]:i<18058?[394,0]:[395,0]:i<19749?[234,2]:i<20528?i<20259?[342,1]:i<20397?[396,0]:[397,0]:i<20783?[344,0]:[398,0]:i<23131?i<21920?i<21551?i<21041?i<20952?[129,0]:[130,0]:[183,1]:i<21665?[131,0]:[185,0]:i<22711?i<22201?i<22057?[132,0]:[133,0]:[186,1]:i<22877?[134,0]:[188,0]:i<25666?i<24661?[237,2]:i<25333?i<25171?[345,1]:i<25253?[399,0]:[400,0]:i<25588?[347,0]:[401,0]:i<27194?i<26686?[240,5]:[242,4]:i<27878?i<27704?[348,1]:i<27782?[402,0]:[403,0]:i<28132?[350,0]:[404,0]:i<47215?i<37491?i<31665?i<30063?i<29101?i<28593?i<28405?[135,0]:[136,0]:[189,1]:i<29555?i<29323?[137,0]:[138,0]:[191,1]:i<30167?i<30080?i<30066?[85,0]:[86,0]:[87,0]:i<31157?i<30649?i<30405?[139,0]:[140,0]:[193,1]:[141,4]:i<35022?i<33697?[243,3]:i<34374?i<34205?[351,1]:i<34293?[405,0]:[406,0]:i<34882?[353,1]:i<34955?[407,0]:[408,0]:i<36546?[247,2]:i<37184?i<37054?[355,1]:i<37126?[409,0]:[410,0]:i<37438?[357,0]:[411,0]:i<42036?i<39930?i<37898?i<37654?i<37558?[88,0]:[89,0]:i<37754?[90,0]:[91,0]:[142,3]:i<40512?i<40272?i<40084?[92,0]:[93,0]:i<40275?[40,0]:[94,0]:[146,2]:i<45145?i<44068?[250,3]:i<44638?i<44576?[358,1]:i<44613?[412,0]:[413,0]:i<45132?i<44892?[360,0]:[361,0]:i<45143?[414,0]:[415,0]:i<46669?[254,2]:i<47062?i<46882?[362,0]:[363,0]:[364,0]:i<56950?i<53201?i<50469?i<48437?i<47767?i<47263?i<47232?[41,0]:[42,0]:i<47513?[95,0]:[96,0]:i<47929?i<47832?[43,0]:[44,0]:[97,1]:[149,3]:i<51677?i<51252?i<50744?i<50583?[45,0]:[46,0]:[99,1]:i<51423?[47,0]:[101,0]:[153,2]:i<55534?i<55233?[257,3]:i<55435?i<55351?[365,0]:[366,0]:i<55494?[367,0]:[368,0]:i<56923?i<56519?i<56042?[261,1]:i<56296?[315,0]:[316,0]:i<56773?[263,0]:[317,0]:i<56948?[369,0]:[370,0]:i<60512?i<59889?i<58365?i<57899?i<57391?i<57152?[48,0]:[49,0]:[102,1]:i<58111?[50,0]:[104,0]:[156,2]:i<60087?i<59926?[51,0]:[105,0]:i<60314?[159,0]:[213,0]:i<61443?i<61171?i<61020?[264,1]:i<61117?[318,0]:[319,0]:i<61421?[266,0]:[320,0]:[267,0];
			}

	}

	function Emitter_emmi_2() {

		var _5s = [[9.85185, 9.25], [19.7037, 9.25], [29.5556, 18.5], [39.4074, 18.5], [9.85185, 18.5], [19.7037, 18.5]], _, _4, _5Srch, _5 = [], _6 = [], _8, _9 = [], _9i, _9s = [], _10 = [], _12, _14, _15, _17, _19, _21, _22, _23=[], _23a=[], _23i=[], _24=[], _24fs=[], _24vs=[], _24rw=[], _24rwn=[], _24rwl, _24v=[], _24p=[], _24dtl, _24dtp, _24df, _24fsd=[], _25, _26, _27, _27i0, _27s0 = [], _28, _29, _29i0, _29s0 = [], _30;
		this.pe = [{xe:0,Rc:10,Sc:5,renderStyleIndex:1}];
		this.name = "emmi_2";

		this.ud = function(Bd) {
			Bd.dd();
			Bd._9 = [
				[[-127.903,-88.9612],[-126.664,-93.1259],[-125.239,-97.231],[-123.617,-101.262],[-121.786,-105.202],[-119.734,-109.032],[-117.454,-112.731],[-114.939,-116.273],[-112.186,-119.634],[-109.197,-122.788],[-105.981,-125.708],[-102.549,-128.373],[-98.9206,-130.762],[-95.117,-132.861],[-91.163,-134.661],[-87.0846,-136.158],[-87.0846,-136.158]]
			];
			Bd._27 = [
				[
					[0.6,0.650561,0.695834,0.736149,0.771888,0.803485,0.831409,0.856157,0.878243,0.898187,0.916501,0.933681,0.950198,0.966494,0.982973,1,1]
				]
			];
			Bd._29 = [
				[
					[0,0.0291447,0.0697997,0.122364,0.18694,0.263151,0.349906,0.445151,0.545668,0.647062,0.744058,0.831122,0.903259,0.956697,0.989199,1,1],
					[1,1,1],
					[1,0.999016,0.995779,0.989793,0.980449,0.966991,0.948465,0.923645,0.89092,0.848121,0.792224,0.718828,0.621157,0.487892,0.297632,0,0]
				]
			];
			Bd.jd = 100;
			Bd.Vc = 0;
		}

		this.Mb = function(vd) {
			vd.zb = 30;
			vd.Gb = 1;
			vd.Jb = 1;
		}

		this.Pb = function(Qb, Bd, vd) {
			vd.zb = 30;
		}

		this.fd = function(Bd, Xb) {
			_ = 1 + Bd.Ld.rand() * (1.5 - 1);
			Xb._1 = _;
			Xb._2 = 0.0;
			Xb._3 = 0;
			_4 = 0 + Bd.Ld.rand() * (1 - 0);
			_5Srch = this._5f(_4 * 61506);
			ctx.yb(_5, 361 + (_5Srch[0] % 54) * 9.85185, 551 + Math.floor(_5Srch[0] / 54) * 9.25, _5s[_5Srch[1]], Bd.Ld.rand);
			ctx.W(_6, _5[0], _5[1], 0);
			Xb._7 = [];
			ctx.T(Xb._7, _6);
			_8 = 0 + Bd.Ld.rand() * (1 - 0);
			_9i = Db.kb(_8);
			ctx.V(_9s,0,(_9i-0)*15);
			Db.lb(_9, Bd._9[_9s[0]], _9s[1]);
			ctx.W(_10, _9[0], _9[1], 0);
			Xb._11 = [];
			ctx.T(Xb._11, _10);
			_12 = 0.2 + Bd.Ld.rand() * (0.4 - 0.2);
			Xb._13 = _12;
			_14 = 0.6 + Bd.Ld.rand() * (1 - 0.6);
			_15 = (_14 * 200);
			Xb._16 = _15;
			_17 = 0 + Bd.Ld.rand() * (360 - 0);
			Xb._18 = _17;
			_19 = -40 + Bd.Ld.rand() * (30 - -40);
			Xb._20 = _19;
			ctx.T(Xb.Ab, Xb._7);
		}

		this.gd = function(Bd, Xb) {
			_ = 1 + Bd.Ld.rand() * (1.5 - 1);
			Xb._1 = _;
			Xb._2 = 0.0;
			Xb._3 = 0;
			_4 = 0 + Bd.Ld.rand() * (1 - 0);
			_5Srch = this._5f(_4 * 61506);
			ctx.yb(_5, 361 + (_5Srch[0] % 54) * 9.85185, 551 + Math.floor(_5Srch[0] / 54) * 9.25, _5s[_5Srch[1]], Bd.Ld.rand);
			ctx.W(_6, _5[0], _5[1], 0);
			Xb._7 = [];
			ctx.T(Xb._7, _6);
			_8 = 0 + Bd.Ld.rand() * (1 - 0);
			_9i = Db.kb(_8);
			ctx.V(_9s,0,(_9i-0)*15);
			Db.lb(_9, Bd._9[_9s[0]], _9s[1]);
			ctx.W(_10, _9[0], _9[1], 0);
			Xb._11 = [];
			ctx.T(Xb._11, _10);
			_12 = 0.2 + Bd.Ld.rand() * (0.4 - 0.2);
			Xb._13 = _12;
			_14 = 0.6 + Bd.Ld.rand() * (1 - 0.6);
			_15 = (_14 * 200);
			Xb._16 = _15;
			_17 = 0 + Bd.Ld.rand() * (360 - 0);
			Xb._18 = _17;
			_19 = -40 + Bd.Ld.rand() * (30 - -40);
			Xb._20 = _19;
			ctx.T(Xb.Ab, Xb._7);
		}

		this.qc = function(Qb, Bd, Xb) {
			Xb._2 += Qb;
			_21 = Xb._3 + Qb * 30;
			Xb._3 = _21;
			_22 = ctx.d(Xb._7, ctx.v([-100, 50, 20], Bd.Rb));
			ctx.u(_23a, [0,0,0], Bd.Ld.Rb);
			ctx.c(_23a, _23a, _22);
			ctx.u(_23i, _23a, 1.0 / 1000); 
			ctx.xb(_23, _23i);
			ctx.k(_23, _23, [-0.00664063,-0.00546875,0]);
			ctx.c(_23, _23, [0.7,0.6,0]);
			ctx.u(_23, _23, 200);
			ctx.T(_24fs, _23);
			ctx.T(_24vs, [0,0,0]);
			_24dtl = Qb;
			ctx.T(_24v, Xb._11);
			ctx.T(_24p, Xb._7);
			while (_24dtl > 0.0001) {
				_24dtp = _24dtl;
				ctx.T(_24fsd, _24fs);
				ctx.g(_24rw, _24vs, _24v);
				_24rwl = ctx.P(_24rw);
				if (_24rwl > 0.0001) {
					_24rwl = Math.sqrt(_24rwl);
					ctx.w(_24rwn, _24rw, _24rwl);
					_24df = 0.01 * 1 * _24rwl;
					if (_24df * _24dtp > 0.2) 
						_24dtp = 0.2 / _24df;
					ctx.c(_24fsd, _24fsd, ctx.v(_24rwn, _24rwl * _24df));
				}
				ctx.c(_24v, _24v, ctx.v(_24fsd, _24dtp));
				ctx.c(_24p, _24p, ctx.v(_24v, _24dtp));
				_24dtl -= _24dtp;
			}
			ctx.T(Xb._7, _24p);
			ctx.T(Xb._11, _24v);
			_25 = Xb._18 + Qb * Xb._20;
			Xb._18 = _25;
			ctx.T(Xb.Ab, Xb._7);
			_26 = (Xb._2 / Xb._1);
			_27i0=(_26<0?0:(_26>1?1:_26));
			ctx.V(_27s0,0,(_27i0-0)*15);
			_27 = Db.nb(Bd._27[0][_27s0[0]],_27s0[1]);
			_28 = (Xb._16 * _27);
			_29i0=(_26<0?0:(_26>1?1:_26));
			_29i0<0.4?_29i0<0.348326?ctx.V(_29s0,0,(_29i0-0)*43.0631):ctx.V(_29s0,1,(_29i0-0.348326)*19.3522):ctx.V(_29s0,2,(_29i0-0.4)*25);
			_29 = Db.nb(Bd._29[0][_29s0[0]],_29s0[1]);
			_30 = (Xb._13 * _29);
			ctx.S(Xb.Pd,[0.5,0.5]);
			Xb.Md = Xb._18;
			ctx.V(Xb.Nd,_28,_28);
			ctx.T(Xb.gf,[1,1,1]);
			Xb.Od = _30;
			Xb.Qc = Xb._3;
		}

		this.Cc = function(Bd, Xb, Wc) {
			return Xb._2 > Xb._1;
		}

			this._5f = function(i) {
				return i<28238?i<12585?i<4936?i<72?i<16?[167,0]:[168,0]:i<2251?i<1147?i<338?i<89?[217,0]:i<115?[270,0]:[271,0]:i<637?i<453?[218,0]:[219,0]:[272,1]:i<1602?i<1531?i<1276?[324,0]:[325,0]:i<1552?[378,0]:[379,0]:i<2111?i<1856?[326,0]:[327,0]:i<2149?[380,0]:[381,0]:i<3744?i<3234?i<2724?i<2472?[220,0]:[221,0]:[274,1]:[222,4]:i<4544?i<4254?[328,1]:i<4387?[382,0]:[383,0]:i<4799?[330,0]:[384,0]:i<5863?i<5324?i<5097?i<5006?[169,0]:[170,0]:i<5202?[171,0]:[172,0]:i<5665?i<5485?[173,0]:[174,0]:[175,0]:i<9644?i<7903?[223,3]:i<8712?i<8413?[331,1]:i<8550?[385,0]:[386,0]:i<9222?[333,1]:i<9420?[387,0]:[388,0]:i<11174?[227,2]:i<12124?i<11684?[335,1]:i<11910?[389,0]:[390,0]:i<12379?[337,0]:[391,0]:i<20876?i<14468?i<13576?i<13057?i<12590?[123,0]:i<12813?[176,0]:[177,0]:i<13075?i<13064?[124,0]:[125,0]:i<13325?[178,0]:[179,0]:i<14155?i<13646?i<13605?[126,0]:[127,0]:i<13900?[180,0]:[181,0]:i<14213?[128,0]:[182,0]:i<18219?i<16506?i<15488?[230,5]:i<15997?i<15742?[232,0]:[233,0]:i<16251?[286,0]:[287,0]:i<17389?i<17016?[338,1]:i<17208?[392,0]:[393,0]:i<17899?[340,1]:i<18058?[394,0]:[395,0]:i<19749?[234,2]:i<20528?i<20259?[342,1]:i<20397?[396,0]:[397,0]:i<20783?[344,0]:[398,0]:i<23131?i<21920?i<21551?i<21041?i<20952?[129,0]:[130,0]:[183,1]:i<21665?[131,0]:[185,0]:i<22711?i<22201?i<22057?[132,0]:[133,0]:[186,1]:i<22877?[134,0]:[188,0]:i<25666?i<24661?[237,2]:i<25333?i<25171?[345,1]:i<25253?[399,0]:[400,0]:i<25588?[347,0]:[401,0]:i<27194?i<26686?[240,5]:[242,4]:i<27878?i<27704?[348,1]:i<27782?[402,0]:[403,0]:i<28132?[350,0]:[404,0]:i<47215?i<37491?i<31665?i<30063?i<29101?i<28593?i<28405?[135,0]:[136,0]:[189,1]:i<29555?i<29323?[137,0]:[138,0]:[191,1]:i<30167?i<30080?i<30066?[85,0]:[86,0]:[87,0]:i<31157?i<30649?i<30405?[139,0]:[140,0]:[193,1]:[141,4]:i<35022?i<33697?[243,3]:i<34374?i<34205?[351,1]:i<34293?[405,0]:[406,0]:i<34882?[353,1]:i<34955?[407,0]:[408,0]:i<36546?[247,2]:i<37184?i<37054?[355,1]:i<37126?[409,0]:[410,0]:i<37438?[357,0]:[411,0]:i<42036?i<39930?i<37898?i<37654?i<37558?[88,0]:[89,0]:i<37754?[90,0]:[91,0]:[142,3]:i<40512?i<40272?i<40084?[92,0]:[93,0]:i<40275?[40,0]:[94,0]:[146,2]:i<45145?i<44068?[250,3]:i<44638?i<44576?[358,1]:i<44613?[412,0]:[413,0]:i<45132?i<44892?[360,0]:[361,0]:i<45143?[414,0]:[415,0]:i<46669?[254,2]:i<47062?i<46882?[362,0]:[363,0]:[364,0]:i<56950?i<53201?i<50469?i<48437?i<47767?i<47263?i<47232?[41,0]:[42,0]:i<47513?[95,0]:[96,0]:i<47929?i<47832?[43,0]:[44,0]:[97,1]:[149,3]:i<51677?i<51252?i<50744?i<50583?[45,0]:[46,0]:[99,1]:i<51423?[47,0]:[101,0]:[153,2]:i<55534?i<55233?[257,3]:i<55435?i<55351?[365,0]:[366,0]:i<55494?[367,0]:[368,0]:i<56923?i<56519?i<56042?[261,1]:i<56296?[315,0]:[316,0]:i<56773?[263,0]:[317,0]:i<56948?[369,0]:[370,0]:i<60512?i<59889?i<58365?i<57899?i<57391?i<57152?[48,0]:[49,0]:[102,1]:i<58111?[50,0]:[104,0]:[156,2]:i<60087?i<59926?[51,0]:[105,0]:i<60314?[159,0]:[213,0]:i<61443?i<61171?i<61020?[264,1]:i<61117?[318,0]:[319,0]:i<61421?[266,0]:[320,0]:[267,0];
			}

	}

	function Emitter_New_Emitter() {

		var _2s = [[9.1, 6.66667], [27.3, 6.66667], [18.2, 6.66667]], _1, _2Srch, _2 = [], _3, _4 = [], _7, _9, _11, _12=[], _12a=[], _12i=[], _13=[], _13fs=[], _13vs=[], _13rw=[], _13rwn=[], _13rwl, _13v=[], _13p=[], _13dtl, _13dtp, _13df, _13fsd=[], _14, _15, _15i0, _15s0 = [], _16, _17, _17i0, _17s0 = [];
		this.pe = [{xe:0,Rc:1,Sc:1,renderStyleIndex:2}];
		this.name = "New_Emitter";

		this.ud = function(Bd) {
			Bd.dd();
			Bd._15 = [
				[
					[0.2,0.239966,0.293608,0.355782,0.423004,0.492712,0.562888,0.631841,0.698078,0.760208,0.81688,0.866719,0.908276,0.939976,0.960044,0.966427,0.966427],
					[0.966427,0.964113,0.959154,0.951077,0.939259,0.922858,0.900682,0.870986,0.831066,0.776521,0.700199,0.59489,0.481452,0.409059,0.377182,0.36875,0.36875],
					[0.36875,0.370184,0.375611,0.385598,0.400791,0.421894,0.449576,0.484263,0.525693,0.572233,0.620299,0.664781,0.700884,0.725925,0.739548,0.742788,0.742788],
					[0.742788,0.738605,0.729486,0.714996,0.694724,0.668323,0.63558,0.596513,0.551467,0.501213,0.446971,0.390347,0.333152,0.277163,0.223904,0.174519,0.174519]
				]
			];
			Bd._17 = [
				[
					[0,0.072521,0.155941,0.24828,0.34653,0.446887,0.545266,0.637914,0.721894,0.795294,0.857157,0.907278,0.94596,0.9738,0.991549,1,1],
					[1,1.00146,0.993328,0.976955,0.953699,0.924925,0.891993,0.856265,0.819104,0.78187,0.745922,0.712614,0.683295,0.659311,0.641999,0.632692,0.632692],
					[0.632692,0.631976,0.636267,0.645086,0.657861,0.67393,0.692549,0.712904,0.734122,0.755293,0.775492,0.793801,0.809332,0.821248,0.828782,0.83125,0.83125],
					[0.83125,0.827554,0.816556,0.797503,0.76963,0.732228,0.684767,0.627067,0.559532,0.48338,0.400778,0.314728,0.228665,0.14589,0.0690706,0,0]
				]
			];
			Bd.jd = 100;
			Bd.Vc = 0;
		}

		this.Mb = function(vd) {
			vd.zb = 8;
			vd.Gb = 1;
			vd.Jb = 1;
		}

		this.Pb = function(Qb, Bd, vd) {
			vd.zb = 8;
		}

		this.fd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 0 + Bd.Ld.rand() * (1 - 0);
			_2Srch = this._2f(_1 * 4015);
			ctx.yb(_2, 784 + (_2Srch[0] % 10) * 9.1, 542 + Math.floor(_2Srch[0] / 10) * 6.66667, _2s[_2Srch[1]], Bd.Ld.rand);
			_3 = -80 + Bd.Ld.rand() * (80 - -80);
			ctx.W(_4, _2[0], _2[1], _3);
			Xb._5 = [];
			ctx.T(Xb._5, _4);
			Xb._6 = [];
			ctx.T(Xb._6, [-50,0,0]);
			_7 = 1 + Bd.Ld.rand() * (2 - 1);
			Xb._8 = _7;
			_9 = 11 + Bd.Ld.rand() * (18 - 11);
			Xb._10 = _9;
			ctx.T(Xb.Ab, Xb._5);
		}

		this.gd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 0 + Bd.Ld.rand() * (1 - 0);
			_2Srch = this._2f(_1 * 4015);
			ctx.yb(_2, 784 + (_2Srch[0] % 10) * 9.1, 542 + Math.floor(_2Srch[0] / 10) * 6.66667, _2s[_2Srch[1]], Bd.Ld.rand);
			_3 = -80 + Bd.Ld.rand() * (80 - -80);
			ctx.W(_4, _2[0], _2[1], _3);
			Xb._5 = [];
			ctx.T(Xb._5, _4);
			Xb._6 = [];
			ctx.T(Xb._6, [-50,0,0]);
			_7 = 1 + Bd.Ld.rand() * (2 - 1);
			Xb._8 = _7;
			_9 = 11 + Bd.Ld.rand() * (18 - 11);
			Xb._10 = _9;
			ctx.T(Xb.Ab, Xb._5);
		}

		this.qc = function(Qb, Bd, Xb) {
			Xb._ += Qb;
			_11 = ctx.d(Xb._5, [(Bd.Rb * 100), 0, 0]);
			ctx.u(_12a, [0,0,0], Bd.Ld.Rb);
			ctx.c(_12a, _12a, _11);
			ctx.u(_12i, _12a, 1.0 / 1000); 
			ctx.xb(_12, _12i);
			ctx.k(_12, _12, [-0.00429688,-0.0015625,0]);
			ctx.c(_12, _12, [0.3,0.2,0]);
			ctx.u(_12, _12, 500);
			ctx.T(_13fs, _12);
			ctx.T(_13vs, [0,0,0]);
			_13dtl = Qb;
			ctx.T(_13v, Xb._6);
			ctx.T(_13p, Xb._5);
			while (_13dtl > 0.0001) {
				_13dtp = _13dtl;
				ctx.T(_13fsd, _13fs);
				ctx.g(_13rw, _13vs, _13v);
				_13rwl = ctx.P(_13rw);
				if (_13rwl > 0.0001) {
					_13rwl = Math.sqrt(_13rwl);
					ctx.w(_13rwn, _13rw, _13rwl);
					_13df = 0.01 * 1 * _13rwl;
					if (_13df * _13dtp > 0.2) 
						_13dtp = 0.2 / _13df;
					ctx.c(_13fsd, _13fsd, ctx.v(_13rwn, _13rwl * _13df));
				}
				ctx.c(_13v, _13v, ctx.v(_13fsd, _13dtp));
				ctx.c(_13p, _13p, ctx.v(_13v, _13dtp));
				_13dtl -= _13dtp;
			}
			ctx.T(Xb._5, _13p);
			ctx.T(Xb._6, _13v);
			ctx.T(Xb.Ab, Xb._5);
			_14 = (Xb._ / Xb._8);
			_15i0=(_14<0?0:(_14>1?1:_14));
			_15i0<0.526569?_15i0<0.275984?ctx.V(_15s0,0,(_15i0-0)*54.351):ctx.V(_15s0,1,(_15i0-0.275984)*59.8599):_15i0<0.734519?ctx.V(_15s0,2,(_15i0-0.526569)*72.1328):ctx.V(_15s0,3,(_15i0-0.734519)*56.5012);
			_15 = Db.nb(Bd._15[0][_15s0[0]],_15s0[1]);
			_16 = (Xb._10 * _15);
			_17i0=(_14<0?0:(_14>1?1:_14));
			_17i0<0.529916?_17i0<0.2?ctx.V(_17s0,0,(_17i0-0)*75):ctx.V(_17s0,1,(_17i0-0.2)*45.4661):_17i0<0.757741?ctx.V(_17s0,2,(_17i0-0.529916)*65.8402):ctx.V(_17s0,3,(_17i0-0.757741)*61.9171);
			_17 = Db.nb(Bd._17[0][_17s0[0]],_17s0[1]);
			ctx.S(Xb.Pd,[0.5,0.5]);
			Xb.Md = 0;
			ctx.V(Xb.Nd,_16,_16);
			ctx.T(Xb.gf,[1,1,1]);
			Xb.Od = _17;
			Xb.Qc = 0;
		}

		this.Cc = function(Bd, Xb, Wc) {
			return Xb._ > Xb._8;
		}

			this._2f = function(i) {
				return i<2187?i<1183?i<874?i<458?i<169?i<11?[0,0]:[1,0]:i<203?[10,0]:[11,0]:i<619?[2,0]:[12,0]:i<1047?i<888?[20,0]:[21,0]:[22,0]:i<2014?i<1505?[3,2]:i<1760?[13,0]:[14,0]:i<2103?[23,0]:[24,0]:i<3682?i<3430?i<3016?i<2507?[5,2]:i<2761?[15,0]:[16,0]:i<3176?[7,0]:[17,0]:[25,1]:i<3962?i<3785?[8,0]:[18,0]:[28,0];
			}

	}

	this.qd = function(Ld) {
		Ld.Dd = 0.0333333;
		Ld.Ud = 0;
		Ld.rand = function() { return Math.random(); };
		Ld.pd(new Emitter_DefaultEmitter());
		Ld.pd(new Emitter_emmi_2());
		Ld.pd(new Emitter_New_Emitter());
	}
			this.kb = function (v) { 				return (v < 0) ? 0 : ((v > 1) ? 1 : v); 			}

			this.lb = function (r, path, je) { 				var indexInt = Math.floor(je); 				var lerp = je - indexInt; 				ctx.Y(r, path[indexInt], path[indexInt + 1], lerp); 			}

			this.nb = function(funcValues, je) { 				var indexInt = Math.floor(je); 				var nextInt = indexInt + 1; 				return ctx.X(funcValues[indexInt], funcValues[nextInt], je - indexInt); 			}

}
